searchNodes=[{"ref":"GenNotify.html","title":"GenNotify","type":"behaviour","doc":"This is the main module that you will come in contact with. you can use this module to inherit its functionality. What is GenNotify You can basically think of it as some kind of broadcast/multicast module. It&#39;s for forwarding Messages to everyone who is in the list of recipients. Example defmodule MyNotification do use GenNotify def on_message(msg) when is_binary(msg) do IO.puts(&quot;I got a message: \#{msg}&quot;) end # we ignore all other kinds of messages def on_message(_msg), do: nil end To get up and running we need to make sure that our Notification Service is started. # lets add our Custom Notification to the list of recipients config = [ recipients: [ MyNotification ] ] GenNotify.Supervisor.start_link(config) If you dont want a Notification to be added to the recipients right away you can start the Service without any recipients and add them later by hand GenNotify.Supervisor.start_link() MyNotification.gen_notify_init() somewhere else in the code... GenNotify.send_notification(&quot;im a message&quot;) # =&gt; This will cause MyNotification.on_message/1 to be called Example - GenServer Sometimes a notification for a module isn&#39;t quite what you want. You want notifications for a specific Process. GenNotify does support GenServer defmodule MyGenServer do use GenServer use GenNotify, gen_server: true # we need to tell GenNotify that this is indeed is a GenServer def start_link(_) do GenServer.start_link(__MODULE__, :ok) end def init(_) do gen_notify_init() # =&gt; This will supply our PID to GenNotify.Notifier (Keep in mind, GenNotify.Supervisor already needs to be alive!) {:ok, %{messages: 0}} end def on_message(msg, state) when is_binary(msg) do new_state = %{state | messages: state.messages + 1} IO.puts(&quot;\#{msg} is my \#{new_state.messages} message!&quot;) # =&gt; will be &quot;im a message is my X message!&quot; in our example # Give the updated state back to the GenServer new_state end # we ignore all other kinds of messages def on_message(_msg, state), do: state end somewhere else in the code... GenNotify.send_notification(&quot;im a message&quot;)"},{"ref":"GenNotify.html#c:on_message/1","title":"GenNotify.on_message/1","type":"callback","doc":"callback which will be invoked when a notification is sent via GenNotify.Notifier.send_notification/1 In case you use GenNotify, gen_server: true then on_message/2 will be called."},{"ref":"GenNotify.html#c:on_message/2","title":"GenNotify.on_message/2","type":"callback","doc":""},{"ref":"GenNotify.html#send_notification/1","title":"GenNotify.send_notification/1","type":"function","doc":"delegation to GenNotify.Notifier.send_notification/1"},{"ref":"GenNotify.html#t:msg/0","title":"GenNotify.msg/0","type":"type","doc":""},{"ref":"GenNotify.html#t:recipient/0","title":"GenNotify.recipient/0","type":"type","doc":""},{"ref":"GenNotify.html#t:state/0","title":"GenNotify.state/0","type":"type","doc":""},{"ref":"GenNotify.Notifier.html","title":"GenNotify.Notifier","type":"module","doc":"The GenNotify.Notifier is the background process of GenNotify. This Module is responsible for sending the notifications and keeps track of the recipients. Do I even need to know about this? You will not need to interact with this Module directly except for starting it via GenNotify.Notifier.start_link/0. Even this will not be needed if you use the GenNotify.Supervisor. The only exception is if you want to implement your own Module with the GenNotify Behaviour (not use GenNotify!)"},{"ref":"GenNotify.Notifier.html#add_recipient/1","title":"GenNotify.Notifier.add_recipient/1","type":"function","doc":"Adds a new recipient to the list of recipients. The list of recipients is always unique. If you try to add the same recipient multiple times it will still only be stored once and therefore GenNotify.on_message/1 will only be called once per notification per module/pid."},{"ref":"GenNotify.Notifier.html#child_spec/1","title":"GenNotify.Notifier.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"GenNotify.Notifier.html#send_notification/1","title":"GenNotify.Notifier.send_notification/1","type":"function","doc":"Sends the message to all known recipients. You can also use GenNotify.send_notification/1 as a shortcut."},{"ref":"GenNotify.Notifier.html#start_link/1","title":"GenNotify.Notifier.start_link/1","type":"function","doc":"returns what GenServer.start_link does"},{"ref":"GenNotify.Supervisor.html","title":"GenNotify.Supervisor","type":"module","doc":"Supervisor to get the GenNotify Module running"},{"ref":"GenNotify.Supervisor.html#child_spec/1","title":"GenNotify.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"GenNotify.Supervisor.html#start_link/1","title":"GenNotify.Supervisor.start_link/1","type":"function","doc":""}]